from typing import Any, Dict, Optional, Type, Union

from _typeshed import Incomplete

SYSTEMD_CONFIG_ROOT: Incomplete
SYSTEMD_NETWORK_CONFIG: Incomplete
SYSTEMD_SERVICE_CONFIG: Incomplete
AnsibleParameter = Dict[str, Any]

class Types:
    def list(
        elements: Union[Type[object], str, AnsibleParameter], required: bool = False, help: Optional[str] = None
    ) -> AnsibleParameter: ...
    def dict(required: bool = False, help: Optional[str] = None, **options: dict) -> AnsibleParameter: ...
    def str(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def bool(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def int(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def float(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def path(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def raw(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def jsonarg(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def json(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def bytes(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...
    def bits(
        required: bool = False,
        help: Optional[str] = None,
        choices: Optional[Sequence] = None,
        default: Optional[Any] = None,
    ) -> AnsibleParameter: ...

def systemdbool(b: Union[bool, str]) -> str: ...
